{ Format: Formate la chaine Format en fonction des arguments passes avec la
  variable Params.

  La chaine Format transmise peut contenir deux types d'objets : les
  caracteres simples et les specificateurs de format. Les caracteres simples
  sont copies tels quels dans la chaine resultante. Les specificateurs de
  format recuperent les arguments dans la liste des arguments en y appliquant
  un format.

  Params doit etre soit un pointeur, soit un entier Longint, soit un reel de
  type Double, soit un TDateTime, ou bien un tableau de l'un de ces types,
  ou bien un enregistrement record ne contenant que ces types, ou encore un
  tableau d'enregistrements.

  Les specificateurs de format ont la forme suivante :

             %[-][[0]Width][.Prec]Type

  Un specificateur de format commence par un caractere %. Ce qui suit % est,
  dans l'ordre :

   L'indicateur facultatif d'alignement a gauche, [-]
   Le specificateur facultatif de taille, [Width], entier compris entre 0
    et 255.
   Le specificateur facultatif de precision, [.Prec], constitue d'un point
    suivi d'un entier compris entre 0 et 18. La valeur par defaut est 2.
   Le caractere de type de conversion, Type

  Le tableau suivant resume les valeurs possibles de type :

  d  Decimal. L'argument doit etre une valeur entiere Longint. La valeur est
     convertie en une chaine de chiffres decimaux. Si la chaine de format
     contient un specificateur de precision, la chaene resultante doit
     contenir au moins le nombre indique de chiffres; si cela n'est pas le
     cas, des caracteres zero de remplissage sont rajoutes dans la partie
     gauche de la chaine.
  u  Decimal sans signe. Comme 'd' mais sans signe en sortie.
  e  Scientifique. L'argument doit etre une valeur flottante de type Double.
     La valeur est convertie en une chaine de la forme "-d.ddd...E+ddd". La
     chaine resultante debute par un signe moins si le nombre est negatif.
     Un chiffre precede toujours le separateur decimal. Le nombre total de
     chiffres dans la chaine resultante (y compris celui qui precede la
     virgule) est donne par le specificateur de precision dans la chaine de
     format. Si celui-ci est omis, une precision de 15 est prise en compte
     par defaut. Le caractere "E" dans la chaine resultante est toujours
     suivi d'un signe plus ou moins, puis de trois chiffres au moins.
  f  Fixe. L'argument doit etre une valeur flottante de type Double. La
     valeur est convertie en une chaine de la forme "-ddd.ddd...". La chaine
     resultante debute par un signe moins si le nombre est negatif. Le nombre
     de chiffres apres la virgule est fourni par le specificateur de
     precision de la chaine de format ; 2 decimales sont prises en compte
     par defaut si le specificateur de precision est omis.
  p  Pointeur. L'argument doit etre une valeur de type pointeur. La valeur
     est convertie en une chaine de 9 caracteres qui represente des valeurs
     de pointeur en hexadecimal, avec un separateur deux-point ":" entre les
     valeurs segment et offset.
  s  Chaine. L'argument doit etre un pointeur vers une chaine de type string.
     La chaine est inseree a la place du specificateur de format.
  c  Caractere. L'argument doit etre un entier Longint, dont l'octet de poids
     faible est converti en un caractere de type Char, insere a la place du
     specificateur de format.
  x  Hexadecimal. L'argument doit etre une valeur entiere de type Longint.
     La valeur est convertie en une chaine de chiffres hexadecimaux. Si la
     chaine de format contient un specificateur de precision, ce dernier
     specifie que la chaine doit contenir au moins le nombre indique de
     chiffres; si cela n'est pas le cas, des caracteres zero de remplissage
     sont rajoutes dans la partie gauche de la chaine. Sinon, la taille est
     adaptee en fonction de la valeur : 2, 4 ou 8 caracteres.
  t  Heure. L'argument doit etre une heure codee sous forme TDateTime. Si la
     chaine contient un specificateur de precision, il defCreate quels sont les
     elements a afficher : 1 pour hh, 2 pour hh:mm, 3 pour hh:mm:ss, et 4
     pour hh:mm:ss, ou hh represente les heures, mm les minutes, ss les
     secondes et  les milliemes de seconde.
  y  Date. L'argument doit etre une date codee sous forme TDateTime. Si la
     chaine contient un specificateur de precision, il defCreate quels sont les
     elements a afficher : 1 pour aaaa, 2 pour mm/aaaa et 3 pour jj/mm/aaaa,
     ou aaaa represente l'annee, mm le mois et jj le jour.
  #  Index d'argument. La largeur Width indique l'index de l'argument a
     utiliser pour le prochain specificateur

  Les caracteres de conversion peuvent etre indiques indifferemment en
  majuscules ou en minuscules : le resultat obtenu est le meme.

  Un specificateur de taille defCreate la taille du champ lors de la
  conversion. Si la chaine resultante est de taille inferieure a la taille
  minimum definie, elle est comblee par des espaces afin d'accroitre la
  taille du champ, ou bien par des zeros, si le specificateur Width est
  precede d'un zero. Si la chaine resultante est trop grande, alors elle
  est tronquee en fonction de l'alignement. Par defaut, le resultat est
  aligne a droite en faisant preceder la valeur d'espaces, mais si le
  specificateur de format contient un indicateur d'alignement a gauche (un
  caractere "-"  precedant le specificateur de taille), le resultat est
  aligne a gauche par l'ajout d'espaces apres la valeur.

  L'indice du premier argument de la liste est 0. A l'aide du specificateur
  d'indice, vous pouvez formater un meme argument plusieurs fois de suite.

}

function Format(AFormat: string; var AParams): string;
const
  HexChars: array[0..15] of Char = '0123456789ABCDEF';
var
  Result: string;
  i: Byte;
  Width: Byte;
  Prec: Byte;
  LeftJustified: Boolean;
  WStr: string[4];
  PStr: string[2];
  e: Integer;
  Filler: Char;
  Index: Word;
  Param: Pointer;
  Temp: string;
  L: Longint;
  Time: TDateTime;
  Hour, Min, Sec, MSec: Word;
begin
Format := '';
Result := '';
i := 1;
Index := 0;
Param := @AParams;
while i <= Length(AFormat) do
  begin
  if AFormat[i] <> '%' then
    begin
    Result := Result + AFormat[i];
    Inc(i);
    end
  else
    begin
    Param := Ptr(Seg(AParams), Ofs(AParams) + Index shl 2);
    Inc(i);
    { Justification droite/gauche }
    if AFormat[i] = '-' then
      begin
      LeftJustified := True;
      Inc(i);
      end
    else LeftJustified := False;
    { Largeur du champ }
    Filler := ' ';
    WStr := '';
    while AFormat[i] in ['0'..'9'] do
      begin
      if Length(WStr) = 3 then Exit;
      WStr := WStr + AFormat[i];
      Inc(i);
      end;
    if WStr <> '' then
      begin
      Val(WStr, Width, e);
      if e <> 0 then Width := 0;
      if WStr[1] = '0' then Filler := '0';
      end
    else Width := 0;

    { Precision pour les nombres a virgule flottante }
    if AFormat[i] = '.' then
      begin
      Inc(i);
      PStr := '';
      while AFormat[i] in ['0'..'9'] do
        begin
        if Length(PStr) = 2 then Exit;
        PStr := PStr + AFormat[i];
        Inc(i);
        end;
      Val(PStr, Prec, e);
      if (e <> 0) or (Prec < 2) or (Prec > 18) then Prec := 0;
      end
    else Prec := 0;

    case UpCase(AFormat[i]) of
    'S': begin
         Temp := PString(Param^)^;
         Inc(Index);
         end;
    'D': begin
         L := Longint(Param^);
         if Prec > 0 then L := Abs(L);
         Str(L, Temp);
         while Prec > 0 do
           Temp := '0' + Temp;
         Inc(Index);
         end;
    'U': begin
         L := Abs(Longint(Param^));
         Str(L, Temp);
         while Prec > 0 do
           Temp := '0' + Temp;
         Inc(Index);
         end;
    'C': begin
         Temp := Char(Pointer(Param^)^);
         Inc(Index);
         end;
    'X': begin
         Temp := '';
         L := Longint(Param^);
         if L > $FFF then
           Temp := Temp + HexChars[(L shr 28) and 15] +
                          HexChars[(L shr 24) and 15] +
                          HexChars[(L shr 20) and 15] +
                          HexChars[(L shr 16) and 15];
         if L > $FF then
           Temp := Temp + HexChars[(L shr 12) and 15] +
                          HexChars[(L shr 8) and 15];
         Temp := Temp + HexChars[(L shr 4) and 15] +
                        HexChars[L and 15];
         if Prec > 0 then
           begin
           while Length(Temp) < Prec do
             Temp := '0' + Temp;
           while (Length(Temp) > Prec) and (Temp[1] = '0') do
             Delete(Temp, 1, 1);
           end;
         Inc(Index);
         end;
    'P': begin
         Temp := '';
         L := Longint(Param^);
         Temp := Temp + HexChars[(L shr 28) and 15] +
                        HexChars[(L shr 24) and 15] +
                        HexChars[(L shr 20) and 15] +
                        HexChars[(L shr 16) and 15] + ':' +
                        HexChars[(L shr 12) and 15] +
                        HexChars[(L shr 8) and 15] +
                        HexChars[(L shr 4) and 15] +
                        HexChars[L and 15];
         Inc(Index);
         end;
    'F': begin
         if Prec = 0 then Prec := 2;
         Str(Double(Param^):0:Prec, Temp);
         Inc(Index, 2);
         end;
    'E': begin
         Str(Double(Param^), Temp);
         if Prec > 0 then
           begin
           while Pos('E', Temp) - Pos('.', Temp) > Prec do
             Delete(Temp, Pos('E', Temp) - 1, 1);
           while Pos('E', Temp) - Pos('.', Temp) < Prec do
             Insert('0', Temp, Pos('E', Temp));
           end;
         Inc(Index, 2);
         end;
    'T': begin
         Time := TDateTime(Param^);
         DecodeTime(Time, Hour, Min, Sec, MSec);
         Str(Hour, PStr);
         if Length(PStr) = 1 then PStr := '0' + PStr;
         Temp := PStr;
         if (Prec = 0) or (Prec >= 2) then
           begin
           Str(Min, PStr);
           if Length(PStr) = 1 then PStr := '0' + PStr;
           Temp := Temp + ':' + PStr;
           end;
         if (Prec = 0) or (Prec >= 3) then
           begin
           Str(Sec, PStr);
           if Length(PStr) = 1 then PStr := '0' + PStr;
           Temp := Temp + ':' + PStr;
           end;
         if Prec >= 4 then
           begin
           Str(MSec, PStr);
           Temp := Temp + ',' + PStr;
           end;
         Inc(Index, 2);
         end;
    'Y': begin
         Time := TDateTime(Param^);
         DecodeDate(Time, Hour, Min, Sec);
         if (Prec = 0) or (Prec = 3) then
           begin
           Str(Sec, PStr);
           if Length(PStr) = 1 then PStr := '0' + PStr;
           Temp := PStr + '/';
           end;
         if (Prec = 0) or (Prec >= 2) then
           begin
           Str(Min, PStr);
           if Length(PStr) = 1 then PStr := '0' + PStr;
           Temp := Temp + PStr + '/';
           end;
         Str(Hour, WStr);
         Temp := Temp + WStr;
         Inc(Index, 2)
         end;
    '#': begin
         Index := Width;
         end;
    else Exit;
    end;
    if AFormat[i] <> '#' then
      begin
      if Width > 0 then
        begin
        if LeftJustified then
          begin
          while Length(Temp) > Width do
            Delete(Temp, Length(Temp), 1);
          while Length(Temp) < Width do
            Temp := Temp + Filler;
          end
        else
          begin
          while Length(Temp) > Width do
            Delete(Temp, 1, 1);
          while Length(Temp) < Width do
            Temp := Filler + Temp;
          end;
        end;
      Result := Result + Temp;
      end;
    Inc(i);
    end;
  end;
Format := Result;
end;